<?php
/**
*
*  @author    Roberto Rivera for dwalins.com
*  @copyright dwalins.com
*  @version   1.0
*  http://dwalins.com
*
*/
if ( !defined( '_PS_VERSION_' ) )
  exit;
 
 
require_once(dirname(__FILE__) . '/classes/Funciones.php');

class Popup extends Module{
	public function __construct(){
		$this->name = 'popup';
		$this->tab = 'Products';
		$this->version = 1.0;
		$this->author = 'Roberto Rivera';
		$this->need_instance = 0;
	 
		parent::__construct();
	 
		$this->displayName = $this->l( 'Popup' );
		$this->description = $this->l( 'Modulo para mostrar un mensaje en la pagina de productos. Sigueme en dwalins.com' );
    }
 
	public function install(){
		$sql = array();
	
        $sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'popup` (
                  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                  `id_product` INT( 11 ) UNSIGNED NOT NULL,
                  `textarea` TEXT NOT NULL,
                  PRIMARY KEY (`id`),
                  UNIQUE  `BELVG_SAMPLE_UNIQ` (  `id_product` )
                ) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8';
				
		if (!parent::install() OR 
            !$this->registerHook('displayAdminProductsExtra') OR
            !$this->registerHook('actionProductUpdate') OR
            !$this->registerHook('displayFooterProduct') OR
			!Configuration::updateValue('sample_module_textarea', '') OR
            !$this->runSql($sql)){
				return FALSE;
        }
		return TRUE;
	}
	public function runSql($sql) {
        foreach ($sql as $s) {
			if (!Db::getInstance()->Execute($s)){
				return FALSE;
			}
        }
        
        return TRUE;
    }
	
	public function uninstall(){
	  if ( !parent::uninstall() )
		Db::getInstance()->Execute( 'DELETE FROM `' . _DB_PREFIX_ . 'popup`' );
	  parent::uninstall();
	}
	
	public function hookDisplayAdminProductsExtra($params) {
        $id_product = Tools::getValue('id_product');

        $sampleObj = Funciones::loadByIdProduct($id_product);
        if(!empty($sampleObj) && isset($sampleObj->id)){
            $this->context->smarty->assign(array(
                'textarea' => $sampleObj->textarea,
            ));
        }
        
        return $this->display(__FILE__, 'views/admin/sample.tpl');
    }
    
    public function hookActionProductUpdate($params) {
		
        $id_product = Tools::getValue('id_product');
        $sampleObj = Funciones::loadByIdProduct($id_product);
		
        $sampleObj->textarea = Tools::getValue('textarea');
        $sampleObj->id_product = $id_product;
        
        if(!empty($sampleObj) && isset($sampleObj->id)){
            $sampleObj->update();
        } else {
            $sampleObj->add();
        }
    }

	
	public function hookDisplayFooterProduct($params){
		// global $smarty;		
		$id_product = Tools::getValue('id_product');
        $sampleObj = Funciones::loadByIdProduct($id_product);
        if(!empty($sampleObj) && isset($sampleObj->id)){
			$this->context->smarty->assign(array(
                'textarea' => $sampleObj->textarea,
            ));
        }
        
		return $this->display( __FILE__, 'views/frontend/footer-product.tpl' );
	}
}
?>